#include<iostream>
#include<vector>
using namespace std;

int mapa_size[ 3 ] = { 0, 0, 0 };

struct mapa_node
{
    mapa_node()
    {
        przejscie[0][0] = 0;
        przejscie[0][1] = 0;
        przejscie[1][0] = 0;
        przejscie[1][1] = 0;
        przejscie[2][0] = 0;
        przejscie[2][1] = 0;
        layer = 0;
    }
	bool przejscie[ 3 ][ 2 ];
	int layer;
};

vector<mapa_node> mapa;
#define M(x,y,z) ((x) + (y)*mapa_size[ 0 ] + (z)*mapa_size[ 0 ]*mapa_size[ 1 ] )
#define MAPA(x,y,z) mapa[((x) + (y)*mapa_size[ 0 ] + (z)*mapa_size[ 0 ]*mapa_size[ 1 ] )]

int main()
{
    ios_base::sync_with_stdio(0);
    srand(124);

    mapa_size[0] = 100;
    mapa_size[1] = 1;
    mapa_size[2] = 100;

    double ciaglosc_sciezki = 0.9;


    cout<<mapa_size[0]<<" "<<mapa_size[1]<<" "<<mapa_size[2]<<endl;

    cout << "0 0 0" << endl;

    mapa.resize(mapa_size[0]*mapa_size[1]*mapa_size[2]);

    int clayer = 0;
    int dead = 0;

    for(int z = 0; z < mapa_size[2]; ++z)
    {
        for(int y = 0; y < mapa_size[1]; ++y)
        {
            for(int x = 0; x < mapa_size[0]; ++x)
            {
                if( MAPA(x,y,z).layer ) continue;

                ++clayer;
                int w[3];
                w[0] = x;
                w[1] = y;
                w[2] = z;

                for(;;)
                {
                    if(rand()%10000 > ciaglosc_sciezki*10000)break;

                    if(dead>50)break;
                    int prev[3];
                    prev[0] = w[0];
                    prev[1] = w[1];
                    prev[2] = w[2];

                    int wymiar = rand()%3;
                    int strona = rand()%2;
                    w[ wymiar ] += strona*2-1;

                    if(w[wymiar]<0 || w[wymiar] >= mapa_size[wymiar] || MAPA(w[0], w[1], w[2]).layer == clayer)
                    {
                        ++dead;
                        w[0] = prev[0];
                        w[1] = prev[1];
                        w[2] = prev[2];
                        continue;
                    }

                    dead = 0;

                    MAPA(prev[0], prev[1], prev[2]).przejscie[wymiar][strona] = 1;
                    MAPA(w[0], w[1], w[2]).przejscie[wymiar][!strona] = 1;


                    if( MAPA(w[0], w[1], w[2]).layer ) break;

                    MAPA(w[0], w[1], w[2]).layer = clayer;
                }
            }
        }
    }



    for(int z = 0; z < mapa_size[2]; ++z)
    {
        for(int y = 0; y < mapa_size[1]; ++y)
        {
            for(int x = 0; x < mapa_size[0]; ++x)
            {
                for(int wymiar = 0; wymiar < 3; ++wymiar)
                {
                    for(int strona = 0; strona < 2; ++strona)
                    {
                        cout<<mapa[M(x,y,z)].przejscie[wymiar][strona]<<" ";
                    }
                    cout<<" ";
                }
                cout<<"\t";
            }

            cout<<endl;
        }

        cout<<endl<<endl;
    }

    return 0;
}
